/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */

package com.jcg.jugglersequence;

/**
 *
 * @author omozegieaziegbe
 */
import java.util.ArrayList;
import java.util.List;

public class JugglerSequence {

    // Method to generate the juggler sequence
    public static List<Integer> generateSequence(int a0) {
        if (a0 <= 0) {
      throw new IllegalArgumentException("Input number must be positive");
    }
        List<Integer> sequence = new ArrayList<>();
        int current = a0;

        // Add the initial term to the sequence
        sequence.add(current);

        // Generate subsequent terms until reaching 1
        while (current != 1) {
            int next;
            if (current % 2 == 0) {
                // If current term is even
                next = (int) Math.sqrt(current);
            } else {
                // If current term is odd
                next = (int) Math.sqrt(current * current * current);
            }
            sequence.add(next);
            current = next;
        }

        return sequence;
    }

    // Method to print the sequence
    public static void printSequence(List<Integer> sequence) {
        System.out.println("Juggler Sequence:");
        for (int num : sequence) {
            System.out.print(num + " ");
        }
        System.out.println();
    }

    // Main method to test the sequence generation
    public static void main(String[] args) {
        int startingNumber = 3;  // Change this to your desired starting number
        List<Integer> jugglerSequence = generateSequence(startingNumber);
        printSequence(jugglerSequence);
    }
}

