/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */

package com.jcg.recursivejugglersequence;

/**
 *
 * @author omozegieaziegbe
 */
import java.util.ArrayList;
import java.util.List;

public class RecursiveJugglerSequence {

    // Method to generate the juggler sequence recursively
    public static List<Integer> generateSequence(int a0) {
        List<Integer> sequence = new ArrayList<>();
        generateSequenceRecursive(a0, sequence);
        return sequence;
    }

    // Helper method for recursive sequence generation
    private static void generateSequenceRecursive(int current, List<Integer> sequence) {
        sequence.add(current); // Add current term to the sequence
        
        if (current == 1) {
            return; // Base case: Sequence terminates when current term is 1
        }

        int next;
        if (current % 2 == 0) {
            next = (int) Math.sqrt(current); // Next term for even current
        } else {
            next = (int) Math.sqrt(current * current * current); // Next term for odd current
        }

        generateSequenceRecursive(next, sequence); // Recursive call with the next term
    }

    // Method to print the sequence
    public static void printSequence(List<Integer> sequence) {
        System.out.println("Juggler Sequence:");
        for (int num : sequence) {
            System.out.print(num + " ");
        }
        System.out.println();
    }

    // Main method to test the recursive sequence generation
    public static void main(String[] args) {
        int startingNumber = 9; // Change this to your desired starting number
        List<Integer> jugglerSequence = generateSequence(startingNumber);
        printSequence(jugglerSequence);
    }
}
